﻿using Hotline.FlowEngine.Workflows;
using Hotline.Share.Dtos.FlowEngine;

namespace Hotline.Application.FlowEngine
{
    public interface IWorkflowApplication
    {
        Task<string> StartWorkflowAsync(StartWorkflowDto dto, string externalId, CancellationToken cancellationToken = default);

        /// <summary>
        /// 流转至下一节点（节点办理）
        /// </summary>
        /// <param name="dto"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task NextAsync(NextWorkflowDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 查询流程下一节点配置参数
        /// </summary>
        /// <param name="moduleCode"></param>
        /// <param name="externalId"></param>
        /// <returns></returns>
        Task<IReadOnlyList<NextStepOptions>> GetNextStepOptionsAsync(string moduleCode, string externalId, CancellationToken cancellationToken);

        Task<IReadOnlyList<NextStepOptions>> GetNextStepOptionsAsync(Workflow workflow, CancellationToken cancellationToken);
    }
}
